/* Dump the contents of a packet to syslog.
 *
 * $Date: 1996/01/31 01:12:53 $
 */

#include "header.h"

char Hex[17] = "0123456789abcdef";

char pchar[257] = "\
......... ......................\
 !\"#$%&'()*+,-./0123456789:;<=>?\
@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\
`abcdefghijklmnopqrstuvwxyz{|}~.\
................................\
................................\
................................\
................................";

void dump_packet(unsigned char *buf, int len)
{
  int i, cnt, first;
  char *hc, *ac;
  char hexbuf[40], ascbuf[40];

  if (buf == NULL || len < 1) return;

  for (i = 0; i < len;) {
    first = i;
    strcpy(hexbuf, "                                    ");
    for (hc = hexbuf, ac = ascbuf, cnt = 0; cnt < 16 && i < len; cnt++, i++) {
      /* Convert octet to hexadecimal */
      *hc++ = Hex[((buf[i] >> 4) & 0x0f)];
      *hc++ = Hex[(buf[i] & 0x0f)];
      if ((cnt & 3) == 3) *hc++ = ' ';

      /* Convert octet to Ascii */
      *ac++ = pchar[buf[i]];
    }
    *ac = '\0';			/* Null terminate the asc string */
    syslog(LOG_NOTICE, "%4d- %s    %s", first, hexbuf, ascbuf);
  }
}
